'simple_backup.vbs

'=-=-=-vύX=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
sBackupRoot = "E:\backup" 'obNAbvۑtH_̃pX
'=-=-=-vύX܂=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
	
Set Fs = WScript.CreateObject("Scripting.FileSystemObject")
Set WshShell = WScript.CreateObject("WScript.Shell")

Set dFolder = WScript.CreateObject("Scripting.Dictionary") 'obNAbvtH_
Set dFile = WScript.CreateObject("Scripting.Dictionary") 'obNAbvt@C
Set dIgnore = WScript.CreateObject("Scripting.Dictionary") 't@CEtH_
Set dReg = WScript.CreateObject("Scripting.Dictionary") 'WXgL[

sRegBackup = sBackupRoot & "\registry"
sLog = Fs.BuildPath(Fs.GetParentFolderName(WScript.ScriptFullName),"log.txt")
sErrorLog = Fs.BuildPath(Fs.GetParentFolderName(WScript.ScriptFullName),"error.txt")
sListFile = Fs.BuildPath(Fs.GetParentFolderName(WScript.ScriptFullName),"backup_list.txt")

If LCase(Fs.GetFileName(WScript.FullName)) = "wscript.exe" Then
	MsgBox "cscriptōċN܂"
	WshShell.Run "cscript """ & WScript.ScriptFullName & """", 1, False
	WScript.Quit
End If

lCheckFile = 0 '`FbNt@C
lCheckFolder = 0 '`FbNtH_
lCheckSize = 0 '`FbNt@C̗e

lUpdateFile = 0 '㏑XVt@C
lNewFile = 0 'Vǉt@C
lNewFolder = 0 'VǉtH_
lDeleteFile = 0 'obNAbv폜t@C
lDeleteFolder = 0 'obNAbv폜tH_
lBackupSize = 0 'obNAbvt@C̗e
lErr = 0 'G[

If Not Fs.FileExists(sListFile) Then
	MsgBox "obNAbvXgt@C܂B"
	WScript.Quit
End If

Set ts = Fs.OpenTextFile(sListFile)

If Not Fs.FolderExists(sBackupRoot) Then
	Fs.CreateFolder sBackupRoot
End If

Do Until ts.AtEndOfStream
	sTemp = ts.ReadLine
	If Left(sTemp,2) = "//" Or sTemp = "" Then
		'RgAs
	ElseIf Left(sTemp,1) = "-" Then
		sTemp=LCase(Mid(sTemp,2))
		If Not dIgnore.Exists(sTemp) Then
			dIgnore.Add sTemp, ""
		End If
	ElseIf Left(sTemp,4) = "HKEY" Then
		If Not dReg.Exists(sTemp) Then
			dReg.Add sTemp, ""
		End If
	Else
		If Fs.FolderExists(sTemp) Then
			dFolder.Add sTemp, ""
		ElseIf Fs.FileExists(sTemp) Then
			dFile.Add sTemp, ""
		End If
	End If
Loop

ts.Close

WriteAndShowLog Date & " " & Time

'WXgobNAbv
WriteAndShowLog "Backup Registry..."
WScript.Echo

If Not Fs.FolderExists(sRegBackup) Then
	Fs.CreateFolder sRegBackup
End If

 'WXgׂďo
'WshShell.Run "regedit /s /e " & sRegBackup & "\all.reg",,True

For Each sReg In dReg.Keys
	WshShell.Run "regedit /s /e " & sRegBackup & "\" & _
	Replace(sReg,"\","_") & ".reg " & sReg,,True
Next

't@CEtH_̃obNAbv
WScript.Echo 
WriteAndShowLog  "Backup files..."
WScript.Echo 

't@C̃obNAbv
For Each sFile In dFile.Keys
	WriteAndShowLog "[" & sFile & "]"
	sTarget = sBackupRoot & "\" & Left(Fs.GetDriveName(sFile), 1) & _
	Mid(Fs.GetParentFolderName(sFile), 3) 
	CreateFolderEx sTarget
	CopyFile Fs.GetFile(sFile), sTarget 'obNAbv
Next

'tH_̃obNAbv
For Each sFolder In dFolder.Keys
	WriteAndShowLog "[" & sFolder & "]"
	CopyFolder Fs.GetFolder(sFolder) 'obNAbv
Next

'obNAbv̍폜
WScript.Echo
WriteAndShowLog  "Check files..."
WScript.Echo

If Fs.FolderExists(sBackupRoot) Then
	On Error Resume Next
	For Each oFolder In Fs.GetFolder(sBackupRoot).SubFolders
		If LCase(oFolder.Path) <> LCase(sRegBackup) Then
			WriteAndShowLog "Check " & oFolder.Path
			DeleteFolder oFolder
		End If
	Next
	On Error Goto 0
End If

WriteAndShowLog vbCrLf & "`FbNt@C " & lCheckFile & vbCrLf & _
"㏑XVt@C " & lUpdateFile & vbCrLf & _
"Vǉt@C " & lNewFile & vbCrLf & _
vbCrLf & _
"`FbNtH_ " & lCheckFolder & vbCrLf & _
"VǉtH_ " & lNewFolder & vbCrLf & _
vbCrLf & _
"`FbNt@C̗e " & ModifySize(lCheckSize) & vbCrLf & _
"obNAbvt@C̗e " & ModifySize(lBackupSize) & vbCrLf & _
vbCrLf & _
"obNAbv폜t@C " & lDeleteFile & vbCrLf & _
"obNAbv폜tH_ " & lDeleteFolder & vbCrLf & _
vbCrLf & _
"G[ " & lErr & vbCrLf & _
"done" & vbCrLf 

Sub WriteAndShowLog(str)
	Set ts1 = Fs.OpenTextFile(sLog, 8, True)
	ts1.Write str & vbCrLf
	ts1.Close
	WScript.Echo str
End Sub

Sub WriteAndShowErrorLog(str)
	Set ts1 = Fs.OpenTextFile(sErrorLog, 8, True)
	ts1.Write str & vbCrLf
	ts1.Close
	WScript.Echo "!!Error!!" & str
End Sub

Sub CopyFile(File, Target)
	't@C̃Rs[
	sTargetFile = Fs.BuildPath(Target, File.Name)
	If Not (dIgnore.Exists(LCase(File.Path)) Or dIgnore.Exists(LCase(File.Name))) Then
		lCheckFile = lCheckFile + 1
		lCheckSize = lCheckSize + File.Size
		sTargetFile = Fs.BuildPath(Target, File.Name)
		If Fs.FileExists(sTargetFile) Then
			Set oTargetFile = Fs.GetFile(sTargetFile)
			If oTargetFile.Size <> File.Size Or Abs(DateDiff("s", oTargetFile.DateLastModified, File.DateLastModified)) > 2 Then
				'TCYႤAŏIXV2secȏĂA
				On Error Resume Next
				File.Copy Target & "\", True'^[Qbg㏑B
				If Err.Number<>0 Then
					WriteAndShowErrorLog File.Path & " can't be updated."
					lErr = lErr + 1
					Err.Clear
				Else
					lUpdateFile = lUpdateFile + 1
					WScript.Echo File.Path & " >> " & Target 
				End If
				On Error Goto 0
			Else
				't@CTCYƍXVȂ牽ȂB
			End If
		Else
			't@C݂ȂȂRs[
			On Error Resume Next
			File.Copy Target & "\"
			If Err.Number<>0 Then
				WriteAndShowErrorLog File.Path & " can't be copied."
				lErr = lErr + 1
				Err.Clear
			Else
				lNewFile = lNewFile + 1
				WScript.Echo File.Path & " > " & Target 
			End If
			On Error Goto 0
		End If
	End If
End Sub

Sub CopyFolder(Folder)
	'tH_̃Rs[
	'̃tH_C:\sBackupRoot\c\ɒutH_B
	sTarget = sBackupRoot & "\" & Left(Fs.GetDriveName(Folder.Path), 1) & Mid(Folder.Path, 3)
	CreateFolderEx sTarget
	lCheckFolder = lCheckFolder + 1
	't@C̃Rs[
	For Each oFile In Folder.Files
		CopyFile oFile,sTarget
	Next
	
	'TutH_
	For Each oSubFolder In Folder.SubFolders
		oSubFolder.Attributes = 0 '
		If Not (dIgnore.Exists(LCase(oSubFolder.Path)) Or dIgnore.Exists(LCase(oSubFolder.Name))) Then
		'XgɓĂȂ΍ċA
			CopyFolder oSubFolder
		End If
	Next
End Sub

Sub DeleteFolder(Folder)
	'obNAbvt@C̍폜
	'obNAbvɂ͂邪AȂt@C/tH_폜
	sSource = Mid(Folder.Path, Len(sBackupRoot) + 2)
	sSource = Left(sSource,1) & ":" & Mid(sSource,2)
	
	If Not Fs.FolderExists(sSource) Then
		On Error Resume Next
		'YobNAbvtH_ARs[ɑ݂Ȃꍇ
		sTempFolderPath = Folder.Path
		Folder.Delete 'obNAbvtH_tH_ƍ폜
		If Err.Number <> 0 Then
			WriteAndShowErrorLog Folder.Path & " can't be deleted."
			lErr = lErr + 1
			Err.Clear
		Else
			lDeleteFolder = lDeleteFolder + 1
			WScript.Echo sTempFolderPath & " deleted."
			Exit Sub
		End If
		On Error Goto 0
	End If
	
	For Each oFile In Folder.Files
		If Not Fs.FileExists(Fs.BuildPath(sSource, oFile.Name)) Then
			'Rs[݂Ȃ
			On Error Resume Next
			sTempFilePath = oFile.Path
			oFile.Attributes = 0 '
			oFile.Delete 'obNAbv폜
			
			If Err.Number<>0 Then
				WriteAndShowErrorLog sTempFilePath & " can't be deleted."
				lErr = lErr + 1
				Err.Clear
			Else
				lDeleteFile = lDeleteFile + 1
				WScript.Echo sTempFilePath & " deleted."
			End If
			On Error Goto 0
		Else
			lBackupSize = lBackupSize + oFile.Size
		End If
	Next
	
	For Each oSubFolder In Folder.SubFolders
		DeleteFolder oSubFolder
	Next
	
End Sub

Sub CreateFolderEx(Path)
	'CɃtH_B
	sParent=Fs.GetParentFolderName(Path)
	If Fs.FolderExists(sParent) And Not Fs.FolderExists(Path) Then
		'etH_݂ÃtH_Ȃꍇ͍
		lNewFolder = lNewFolder + 1
		Fs.CreateFolder Path
	ElseIf Fs.FolderExists(Path) Then
		'tH_遨Ȃ
	Else
		'etH_Ȃꍇ͐etH_ĂAYtH_B
		CreateFolderEx sParent
		Fs.CreateFolder Path
		lNewFolder = lNewFolder + 1
	End If
End Sub

Function ModifySize(sz)
	If sz >= 1073741824 Then
		ModifySize = CSng(Left(sz/1073741824,4)) & "GB"
	ElseIf sz >= 1048576 Then
		ModifySize = CSng(Left(sz/1048576,4)) & "MB"
	ElseIf sz >= 1024 Then
		ModifySize = CSng(Left(sz/1024,4)) & "KB"
	Else
		ModifySize = FormatNumber(sz,0) & "oCg"
	End If 
End Function 
